; Header file, this is what goes at 0x0000 of page 0x00.

; RST 0x00
    jp boot
.fill 0x08-$
; RST 0x08
    ret             ; KNIGHTOS K-HANDLER
.fill 0x10-$
; RST 0x10
    ret             ; KNIGHTOS L-HANDLER/I-HANDLER
.fill 0x18-$
; RST 0x18
    ret
.fill 0x20-$
; RST 0x20
    ret
.fill 0x28-$
; RST 0x28
    ret             ; TIOS BCALL
.fill 0x30-$
; RST 0x30
    ret
.fill 0x38-$
; RST 0x38
    jp sysInterrupt ; SYSTEM INTERRUPT

.fill 0x53-$
    jp boot
.db 0xFF, 0xA5, 0xFF
#ifdef TI84pSE
.fill 0x64-$
    .db '2' ; For the sake of WabbitEmu, this convinces it that it's a TI-84+ SE
#endif