; Keyboard-relative functions and defines
kF1toF5plus2MD .equ %10111111
k1stCol .equ %11011111
k2ndCol .equ %11101111
k3rdCol .equ %11110111
k4thCol .equ %11111011
k5thCol .equ %11111101
kArrows .equ %11111110

; Inputs :
;   a = group to check
; Outputs :
;   a = keys pressed with 0 is pressed
directIn:
	out (1),a
	in a,(1)
	ret

; Inputs : nothing
; Outptus :
;	a = key pressed
getKey:
	
	; Check arrows
	ld a,kArrows
	call directIn
	cpl

	bit 0,a
	jr z,+_
	ld a,1
	ret
_:
	bit 1,a
	jr z,+_
	ld a,2
	ret
_:
	bit 2,a
	jr z,+_
	ld a,3
	ret
_:
	bit 3,a
	jr z,+_
	ld a,4
	ret
_:

	; Check 5th col
	ld a,k5thCol
	call directIn
	cpl

	bit 0,a
	jr z,+_
	ld a,9
	ret
_:
	bit 1,a
	jr z,+_
	ld a,10
	ret
_:
	bit 2,a
	jr z,+_
	ld a,11
	ret
_:
	bit 3,a
	jr z,+_
	ld a,12
	ret
_:
	bit 4,a
	jr z,+_
	ld a,13
	ret
_:
	bit 5,a
	jr z,+_
	ld a,14
	ret
_:
	bit 6,a
	jr z,+_
	ld a,15
	ret
_:

	; Check 4th col
	ld a,k4thCol
	call directIn
	cpl

	bit 0,a
	jr z,+_
	ld a,17
	ret
_:
	bit 1,a
	jr z,+_
	ld a,18
	ret
_:
	bit 2,a
	jr z,+_
	ld a,19
	ret
_:
	bit 3,a
	jr z,+_
	ld a,20
	ret
_:
	bit 4,a
	jr z,+_
	ld a,21
	ret
_:
	bit 5,a
	jr z,+_
	ld a,22
	ret
_:
	bit 6,a
	jr z,+_
	ld a,23
	ret
_:

	; Check 3rd col
	ld a,k3rdCol
	call directIn
	cpl

	bit 0,a
	jr z,+_
	ld a,25
	ret
_:
	bit 1,a
	jr z,+_
	ld a,26
	ret
_:
	bit 2,a
	jr z,+_
	ld a,27
	ret
_:
	bit 3,a
	jr z,+_
	ld a,28
	ret
_:
	bit 4,a
	jr z,+_
	ld a,29
	ret
_:
	bit 5,a
	jr z,+_
	ld a,30
	ret
_:
	bit 6,a
	jr z,+_
	ld a,31
	ret
_:
	bit 7,a
	jr z,+_
	ld a,32
	ret
_:

	; Check 2nd col
	ld a,k2ndCol
	call directIn
	cpl

	bit 0,a
	jr z,+_
	ld a,33
	ret
_:
	bit 1,a
	jr z,+_
	ld a,34
	ret
_:
	bit 2,a
	jr z,+_
	ld a,35
	ret
_:
	bit 3,a
	jr z,+_
	ld a,36
	ret
_:
	bit 4,a
	jr z,+_
	ld a,37
	ret
_:
	bit 5,a
	jr z,+_
	ld a,38
	ret
_:
	bit 6,a
	jr z,+_
	ld a,39
	ret
_:
	bit 7,a
	jr z,+_
	ld a,40
	ret
_:

	; Check 1st col
	ld a,k1stCol
	call directIn
	cpl

	bit 0,a
	jr z,+_
	ld a,41
	ret
_:
	bit 1,a
	jr z,+_
	ld a,42
	ret
_:
	bit 2,a
	jr z,+_
	ld a,43
	ret
_:
	bit 3,a
	jr z,+_
	ld a,44
	ret
_:
	bit 4,a
	jr z,+_
	ld a,45
	ret
_:
	bit 5,a
	jr z,+_
	ld a,46
	ret
_:
	bit 6,a
	jr z,+_
	ld a,47
	ret
_:
	bit 7,a
	jr z,+_
	ld a,48
	ret
_:

	; Check F1-F5, 2nd, mode and del
	ld a,kF1toF5plus2MD
	call directIn
	cpl

	bit 0,a
	jr z,+_
	ld a,49
	ret
_:
	bit 1,a
	jr z,+_
	ld a,50
	ret
_:
	bit 2,a
	jr z,+_
	ld a,51
	ret
_:
	bit 3,a
	jr z,+_
	ld a,52
	ret
_:
	bit 4,a
	jr z,+_
	ld a,53
	ret
_:
	bit 5,a
	jr z,+_
	ld a,54
	ret
_:
	bit 6,a
	jr z,+_
	ld a,55
	ret
_:
	bit 7,a
	jr z,+_
	ld a,56
	ret
_:

	ld a,0
	ret

waitNoKey:
	call getKey
	or a
	jr nz,waitNoKey
	ret

waitForKey:
	call getKey
	or a
	jr z,waitForKey
	ret
