    jp 0 ; Safety, prevents runaway code from unlocking flash
unlockFlash:
    push af
    push bc
    in a, (6)
    push af
    ld a, privledgedPage
    out (6), a
    ld b, 0x01
    ld c, 0x14
    call 0x4001
    pop af
    out (6), a
    pop bc
    pop af
    ret

lockFlash:
    push af
    push bc
    in a, (6)
    push af
    ld a, privledgedPage
    out (6), a
    ld b, 0x00
    ld c, 0x14
    call 0x4017
    pop af
    out (6), a
    pop bc
    pop af
    ret